/**
 * 加载到外部URL的文件，用于下载图片；
 */
/**
 * 打开长按事件
 * http://dev.dcloud.net.cn/mui/event/#gesture
 */
mui.init({
	gestureConfig: {
		longtap: true
	}
});
mui.plusReady(function() {
	document.addEventListener("longtap", function(event) {
		//获取目标节点的tagName
		var name = event.target.tagName;
		name = name.toLowerCase();
		//如果是图片，则弹出选择框决定是否下载；
		if(name === "img") {
			
			var imgUrl = event.target.src;
			console.log('图片地址：' + imgUrl);
			var suffix = cutImageSuffix(imgUrl);
			//dialog弹窗 http://dev.dcloud.net.cn/mui/ui/#dialog
			mui.confirm("是否保存此图片", "确认下载？", ["下载", "取消"], function(event) {
				//index从0开始
				var index = event.index;
				if(index == 0) {
					if(imgUrl.indexOf("data:")!=-1){
						//base64保存
						imageDown(imgUrl,function(){
							//保存成功
							plus.nativeUI.toast("保存成功");
							
						},function(){
							//保存失败
							plus.nativeUI.toast("保存失败");
						});
						
					}else{
						if(!checkURL(imgUrl)){
							//检查是否为本地文件 本地文件拼接域名
							imgUrl = fileDormain()+imgUrl;
						}
						//src的下载
						downloadImageURL(imgUrl,suffix);
					}
				}
			});
		}
	});
});

//获取本地文件的域名
function fileDormain(){
    var url = window.location.href;
    var urlstr = url.split("/"); //以“/”进行分割
    var urls = '';
    if (urlstr[2]) {
        urls = urlstr[0]+'//'+urlstr[2];
    }
    return urls;
}

//http图片链接下载
function downloadImageURL(imgUrl,suffix){
	/**
	 * 创建下载任务
	 * http://www.html5plus.org/doc/zh_cn/downloader.html#plus.downloader.createDownload
	 */
	var downLoader = plus.downloader.createDownload(imgUrl, {
		method: 'GET',
		filename: '_downloads/image' + suffix
	}, function(download, status) {
		var fileName = download.filename;
		console.log('文件名:' + fileName);
		console.log('下载状态：' + status);
		/**
		 * 保存至本地相册
		 * http://www.html5plus.org/doc/zh_cn/gallery.html#plus.gallery.save
		 */
		plus.gallery.save(fileName, function() {
			plus.nativeUI.toast("保存成功");
		},function(){
			plus.nativeUI.toast("保存失败");
		});
	});
	/**
	 * 开始下载任务
	 * http://www.html5plus.org/doc/zh_cn/downloader.html#plus.downloader.Download.start
	 */
	downLoader.start();
}


//判断图片地址是否是HTTP的
function checkURL(URL){
	var str=URL;
	//判断URL地址的正则表达式为:http(s)?://([\w-]+\.)+[\w-]+(/[\w- ./?%&=]*)?
	//下面的代码中应用了转义字符"\"输出一个字符"/"
	var Expression=/http(s)?:\/\/([\w-]+\.)+[\w-]+(\/[\w- .\/?%&=]*)?/;
	var objExp=new RegExp(Expression);
	if(objExp.test(str)==true){
		return true;
	}else{
		return false;
	}
} 
//保存到相册
function imageSaveByGallery(url, success, error) {
	window.plus.gallery.save(url, function (event) {
		
		const tarbitmap = window.plus.nativeObj.Bitmap.getBitmapById('image');
		tarbitmap.clear();
		success();
	}, function (err) {
		window.plus.nativeUI(err.message);
		error();
	})
}

//bitmap转成图片
function bigmapToSave(bitmap, success, error) {
	var name = randomString(10);
	bitmap.save(`_doc/${name}.jpg`, { overwrite: false }, function (event) {
		console.log(event.target);
		imageSaveByGallery(event.target, success, error)
	}, function (err) {
		window.plus.nativeUI(err.message)
	});
}
//base64转成bitmap
function imageDown(base64, success, error) {
	var bitmap = new window.plus.nativeObj.Bitmap('image');
	bitmap.loadBase64Data(base64, function (i) {
		bigmapToSave(bitmap, success, error);
	}, function (err) {
		window.plus.nativeUI(err.message);
	})
}

//随机生成字符串
function randomString (e) {
	e = e || 32;
	var t = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
	var a = t.length;
	var n = '';
	for (var i = 0; i<e;i++){
		n += t.charAt(Math.floor(Math.random() * a));
	}
	return n
}

// 截取图片后缀用于重命名图片，防止%E5%85%89%E6%98%8E%E8%A1%8C编码的文件不被系统相册识别；
function cutImageSuffix(imageUrl) {
	var index = imageUrl.lastIndexOf('.');
	return imageUrl.substring(index);
}