/**
 * 加载到外部URL的文件，用于下载图片；
 */
/**
 * 打开长按事件
 * http://dev.dcloud.net.cn/mui/event/#gesture
 */
mui.init({
	gestureConfig: {
		tap: true
	}
});
mui.plusReady(function() {
	document.addEventListener("tap", function(event) {
		//获取目标节点的tagName
		var name = event.target.tagName;
		name = name.toLowerCase();
		// event.preventDefault();
		// event.stopPropagation();
		event.stopImmediatePropagation()
		alert(name);
		//如果是图片，则弹出选择框决定是否下载；
		if(name === "a") {
			
			var href = event.target.href;
			console.log('图片地址：' + href);

			//dialog弹窗 http://dev.dcloud.net.cn/mui/ui/#dialog
			mui.confirm("是否下载此文件", "确认下载？", ["下载", "取消"], function(event) {
				//index从0开始
				var index = event.index;
				if(index == 0) {
					if(!checkURL(href)){
						//检查是否为本地文件 本地文件拼接域名
						href = fileDormain()+href;
					}
					//src的下载
					downloadImageURL(href,randomString(10));
				}
			});
		}
	});
});

//获取本地文件的域名
function fileDormain(){
    var url = window.location.href;
    var urlstr = url.split("/"); //以“/”进行分割
    var urls = '';
    if (urlstr[2]) {
        urls = urlstr[0]+'//'+urlstr[2];
    }
    return urls;
}

//http图片链接下载
function downloadImageURL(imgUrl,suffix){
	/**
	 * 创建下载任务
	 * http://www.html5plus.org/doc/zh_cn/downloader.html#plus.downloader.createDownload
	 */
	var downLoader = plus.downloader.createDownload(imgUrl, {
		method: 'GET',
		filename: '_downloads/file/' + suffix
	}, function(download, status) {
		var fileName = download.filename;
		console.log('文件名:' + fileName);
		console.log('下载状态：' + status);
		if(status==200){
			
		}
	});
	downLoader.addEventListener( "statechanged", function(task,status){
		switch(task.state) {
			case 1: // 
			console.log('开始下载')
				break;
			case 2: // 已连接到服务器
				console.log( "链接到服务器..." );
			break;
			case 3:	// 已接收到数据
				console.log( "下载数据更新:" );
				console.log( task.downloadedSize+"/"+task.totalSize );
			break;
			case 4:	// 下载完成
				console.log( "下载完成！" );
				console.log(JSON.stringify(task));
				saveFile(task.filename,suffix);

			break;
		}
	} );
	/**
	 * 开始下载任务
	 * http://www.html5plus.org/doc/zh_cn/downloader.html#plus.downloader.Download.start
	 */
	downLoader.start();
}
//保存文件
function saveFile(filpath,fileName){
          plus.io.requestFileSystem( plus.io.PUBLIC_DOWNLOADS, function( fs ) {
            // fs.root是根目录操作对象DirectoryEntry
            // console.log("url="+fs.toURL());
            fs.root.getFile(fileName,{create:true}, function(fileEntry){
                fileEntry.createWriter( function ( writer ) {
                    writer.onwrite = function ( e ) {
                        console.log( "Write data success!" );
                    };
                    // let data = JSON.stringify(news);
                    // writer.seek(0);
                    // writer.write(data);
                    // callback({state:1,message:"保存数据成功！"});
                }, function ( e ) {
 
                } );
            });
        }, function ( e ) {
        } );
};


//判断图片地址是否是HTTP的
function checkURL(URL){
	var str=URL;
	//判断URL地址的正则表达式为:http(s)?://([\w-]+\.)+[\w-]+(/[\w- ./?%&=]*)?
	//下面的代码中应用了转义字符"\"输出一个字符"/"
	var Expression=/http(s)?:\/\/([\w-]+\.)+[\w-]+(\/[\w- .\/?%&=]*)?/;
	var objExp=new RegExp(Expression);
	if(objExp.test(str)==true){
		return true;
	}else{
		return false;
	}
} 


//随机生成字符串
function randomString (e) {
	e = e || 32;
	var t = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
	var a = t.length;
	var n = '';
	for (var i = 0; i<e;i++){
		n += t.charAt(Math.floor(Math.random() * a));
	}
	return n
}
