//  ios下监听document中的plusready而不是wap2app.plusReady，防止DOM节点不存在；
document.addEventListener('plusready', function() {
	// iOS下对视频播放全屏的横屏操作
	if(plus.os.name=="iOS") {
		var videoElem = document.querySelector('video'); //video元素
		// video元素开始全屏
		videoElem.addEventListener('webkitbeginfullscreen', function() {
			plus.screen.lockOrientation('landscape');
			plus.nativeUI.toast("aaaaaaaaaa")
		});
		// video元素全屏结束
		videoElem.addEventListener('webkitendfullscreen', function() {
			plus.screen.lockOrientation('portrait');
		});
	}
	// 在安卓环境中，通常情况下需要html页面解析完成后才会让5+ API生效。所以在docment的ready事件触发之后wap2app.plusReady事件执行
	// Android下对视频播放全屏的横屏操作
	if(plus.os.name=='Android') {
		var self = plus.webview.currentWebview();
		self.setStyle({
			videoFullscreen: 'landscape' //横屏
		});
		
		document.addEventListener('webkitfullscreenchange', function() {
			var el = document.webkitFullscreenElement;
			if (el) {
				plus.screen.lockOrientation('landscape')
			} else {
				plus.screen.unlockOrientation()
			}
		})
	}
})


var fullScreenOfAndroid = function() {
	if (true) {
		var playym = plus.webview.currentWebview();
		playym.setStyle({
			videoFullscreen: 'landscape'
		})
	} else {
		document.addEventListener('webkitfullscreenchange', function() {
			var el = document.webkitFullscreenElement;
			if (el) {
				plus.screen.lockOrientation('landscape')
			} else {
				plus.screen.unlockOrientation()
			}
		})
	}
};
var fullScreenOfIos = function(videoElem) {
	videoElem.addEventListener('webkitbeginfullscreen', function() {
		plus.screen.lockOrientation('landscape')
	});
	videoElem.addEventListener('webkitendfullscreen', function() {
		plus.screen.unlockOrientation()
	})
};
